package de.uks.plm.ftglb.actor.logEvents;

public abstract class LogEvent
{
  /** Vorgänger und Nachfolger des LogEvents in der doppelt verketteten List der
  * LogEvents. */
  public var prevLE:LogEvent;
  public var nextLE:LogEvent;

  /** Typ des LogEvents. */
  public var label:String;
  /** Absolute Startzeit des LogEvents. */
  public var sTime:Long;
  /** Absoulte zwischenzeit zum messen des durch den LogManager verursachten
    * Overheads. Wird am Ende von StartLE oder EndLE gesetzt.*/
  public var wTime:Long;
  /** Absolute Endzeit des LogEvents. */
  public var eTime:Long;


  /** Zeigt auf den ersten Teil eines unterbrochenen LogEvents. Wenn das LogEvent
    * nich unterbrochen wurde, zeigt es auf das LogEvent selbst. */
  public var firstPartLE:LogEvent;
  /** Schritte zum vorherigen Teil des LogEvents. 0 wenn das LogEvent selbst der
    * erste Teil ist. */
  public var predecessor:Long;
  /** Schritte zum nächsten Teil des LogEvents. 0 wenn das LogEvent selbst der
    * letzte Teil ist. */
  public var successor:Long;

  /** Methode zur Ausgabe der Felder des LogEvents in einen String. Die gemessenen
    * Absolutzeiten werden dabei mit der Referenzzeit verrechnet. */
  public abstract def toString(refTime:Long) : String;

  /** Methode zur Nachbearbeitung der Felder. Wird aufgerufen bevor das Logfile
    * geschrieben wird. */
  public abstract def postprocessing() : void;
  /*public def startWaiting(waitingTimeStart:Long) : void
  {
  }
  public def endWaiting(waitingTimeEnd:Long) : void
  {
  }*/
}
