package de.uks.plm.ftglb.actor.logEvents;

import x10.xrx.Runtime;
import x10.util.ArrayList;
import x10.util.Pair;
import x10.compiler.Inline;
import x10.util.StringBuilder;

/* Zeit zum erzeugen einer Objektinstaz etwa 10000 - 30000 ns. Ein Aufruf von
   setStartTime und setEndTime etwa 60 ns. */

public class SimpleLogEvent
{
  private static val CURR_ASSERT_LEVEL:Long = 2;
  private static val ASSERT_LEVEL:Long = 2;
  //Intervall length in ns.
  public static val INTERVALL_LENGTH:Long  = 100000000;
  //Program runtime should INTERVALL_LENGTH * ARRAY_LENGTH.
  private static val ARRAY_LENGTH:Long = 500;

  private var refTime:Long;
  private var currIntEnd:Long;

  private val label:String;
  private var startTime:Long;
  private var endTime:Long;
  /* [sumTime, count] */
  private var results:ArrayList[Pair[ULong, ULong]];
  //private var resultsSum:ArrayList[ULong];
  //private var resultsCount:ArrayList[ULong];
  private var sumTime:ULong;
  private var diffTime:ULong;
  private var count:ULong;

  public def this(label:String, refTime:Long)
  {
    this.label = label;
    this.refTime = refTime;
    this.currIntEnd = refTime + INTERVALL_LENGTH;
    this.startTime = 0;
    this.endTime = 0;
    this.results = new ArrayList[Pair[ULong, ULong]](ARRAY_LENGTH);
    //this.resultsSum = new ArrayList[ULong](ARRAY_LENGTH);
    //this.resultsCount = new ArrayList[ULong](ARRAY_LENGTH);
    this.sumTime = 0ul;
    this.diffTime = 0ul;
    this.count = 0ul;
  }

  public def this(label:String)
  {
    this.label = label;
    this.startTime = 0;
    this.endTime = 0;
    this.results = new ArrayList[Pair[ULong, ULong]](ARRAY_LENGTH);
    //this.resultsSum = new ArrayList[ULong](ARRAY_LENGTH);
    //this.resultsCount = new ArrayList[ULong](ARRAY_LENGTH);
    this.sumTime = 0ul;
    this.diffTime = 0ul;
    this.count = 0ul;
    this.refTime = 0;
  }
  public def setRefTime(refTime:Long) : void
  {
    this.refTime = refTime;
    this.currIntEnd = this.refTime + INTERVALL_LENGTH;
  }
  @Inline public def setST() : void
  {
    if (ASSERT_LEVEL == CURR_ASSERT_LEVEL)
    {
      //assert(setStartTime());
      setStartTime();
    }
  }
  @Inline private def setStartTime() : Boolean
  {
    this.startTime = System.nanoTime();
    while (startTime >= currIntEnd)
    {
      val entry:Pair[ULong, ULong] = new Pair[ULong, ULong](sumTime, count);
      this.results.add(entry);
      //this.resultsSum.add(sumTime);
      //this.resultsCount.add(count);
      sumTime = 0ul;
      count = 0ul;
      currIntEnd = currIntEnd + INTERVALL_LENGTH;
    }
    return true;
  }
  @Inline public def setET() : void
  {
    if (ASSERT_LEVEL == CURR_ASSERT_LEVEL)
    {
      //assert(setEndTime());
      setEndTime();
    }
  }
  @Inline private def setEndTime() : Boolean
  {
    this.endTime = System.nanoTime();
    this.diffTime = ((this.endTime - this.startTime) as ULong);
    this.sumTime = this.sumTime + this.diffTime;
    this.count = this.count + 1ul;
    return true;
  }
  /* End logging and return the results as a String. Wird am ende vom LogManager
   * abgeholt.*/
  public def toString() : String
  {
    val entry:Pair[ULong, ULong] = new Pair[ULong, ULong](sumTime, count);
    this.results.add(entry);
    //this.resultsSum.add(sumTime);
    //this.resultsCount.add(count);
    //Console.OUT.println("Arraylaenge = " + this.results.size());
    //return this.label + " " + results.toString();
    //return this.label + " : \n" + resultsSum + "\n" + resultsCount;
    val sb = new StringBuilder();
    sb.add(this.label + "");
    //sb.add("[");
    for (e:Pair[ULong, ULong] in results)
    {
      //if (indexOf(e) > 0)
      //{
        sb.add(" ");
      //}
      sb.add("" + e);
    }
    //sb.add("]");
    return sb.toString();
  }
}
