package de.uks.plm.ftglb.actor.managers;

import x10.compiler.Inline;
import x10.util.ArrayList;

public final class ProcessingStackManager
{
  
  private static val ARRAY_LENGTH:Long = 10000;
  // Sollte ich mir sparen können, noch zum debugging drin lassen.
  private var workingIsRunning : Boolean;

  private var startMeasurement : Long;
  private var endMeasurement : Long;
  private var processingTime : Long;
  
  private var psList:ArrayList[Long];
  public def this()
  {
    this.workingIsRunning = false;
    this.startMeasurement = -1;
    this.endMeasurement = -1;
    this.processingTime = 0;
    this.psList = new ArrayList[Long](10000);
  }

  /* Wird beim betreten der Schleife mit queue.process() aufgerufen. */
  @Inline public def startProcessing() : void
  {
    if(workingIsRunning == true)
    {
      this.startMeasurement = System.nanoTime();
    }
  }

  /* Wird beim verlassen der Schleife mit queue.process() aufgerufen. 
   * Beendet die Messung der Zeit und addiert sie auf die Gesamtzeit auf.*/
  @Inline public def endProcessing() : void
  {
    if(workingIsRunning == true)
    {
      this.endMeasurement = System.nanoTime();
      this.calcTime();
    }
  }

  /* Wird aufgerufen beim starten von Working. Aktiviert die Zeitmessung. */
  @Inline public def startWorking() : void
  {
    this.resetMeasurement();
    this.workingIsRunning = true;
  }

  @Inline public def endWorking() : void
  {
    this.workingIsRunning = false;
    this.addResult();
  }

  @Inline private def calcTime() : void
  {
    this.processingTime = this.processingTime + (this.endMeasurement - this.startMeasurement);
  }

  @Inline private def resetMeasurement() : void
  {
    this.processingTime = 0;
  }
  
  @Inline private def addResult() : void
  {
    this.psList.add(this.processingTime);
  }

  @Inline public def getProcessing() : ArrayList[Long]
  {
    return this.psList;
  }
}
