package de.uks.plm.ftglb.actor.producerConsumer;

import de.uks.plm.ftglb.actor.TaskBag;

public class Bag implements TaskBag
{
    public var depth:Rail[Long];
    public var upper:Rail[Long];
    public var lower:Rail[Long];

    public def this(val size:Long) : Bag
    {
        this.upper = new Rail[Long](size);
        this.lower = new Rail[Long](size);
        this.depth = new Rail[Long](size);
    }

    public def merge(val bag:TaskBag) : void
    {
        this.merge(bag as Bag);
    }

    public def merge(val that:Bag) : void
    {
        val thisSize:Long = this.size();
        val thatSize:Long = that.size();
        val newSize:Long = thisSize + thatSize;
        val newUpper:Rail[Long] = new Rail[Long](newSize);
        val newLower:Rail[Long] = new Rail[Long](newSize);
        val newDepth:Rail[Long] = new Rail[Long](newSize);

        Rail.copy(this.upper, 0, newUpper, 0, thisSize);
        Rail.copy(that.upper, 0, newUpper, thisSize, thatSize);

        Rail.copy(this.lower, 0, newLower, 0, thisSize);
        Rail.copy(that.lower, 0, newLower, thisSize, thatSize);

        Rail.copy(this.depth, 0, newDepth, 0, thisSize);
        Rail.copy(that.depth, 0, newDepth, thisSize, thatSize);
    }

    public def size() : Long
    {
        return (this.lower.size);
    }

    public def toString() : String
    {
        var s:String = "Bag:\n";
        for (var i:Long = 0; i < this.lower.size; ++i)
        {
            s +=  "   Depth = " + this.depth(i) + ", lower = " + this.lower(i)
                + " upper = " + this.upper(i) + "\n";
        }
        s += "size = " + this.size();
        return (s);
    }
}
