package de.uks.plm.ftglb.actor.utsg;

import x10.compiler.*;

import de.uks.plm.ftglb.actor.TaskBag;

public final class Bag implements TaskBag
{
    public var hash:Rail[SHA1Rand];
    public var lower:Rail[Int];
    public var upper:Rail[Int];
    
    public def this(size:Long)
    {
        hash = new Rail[SHA1Rand](size);
        lower = new Rail[Int](size);
        upper = new Rail[Int](size);
    }

    @Inline public def merge(that:TaskBag) : void
    {
        this.merge(that as Bag);
    }

    @Inline public def merge(that:Bag) : void
    {
        val thisSize:Long = this.size();
        if (0 == thisSize)
        {
            this.hash = that.hash;
            this.lower = that.lower;
            this.upper = that.upper;
            return;
        }

        val thatSize:Long = that.size();
        if ((null == that) || (0 == thatSize))
        {
            return;
        }

        val newSize:Long = thisSize + thatSize;
        val newHash:Rail[SHA1Rand] = new Rail[SHA1Rand](newSize);
        val newLower:Rail[Int] = new Rail[Int](newSize);
        val newUpper:Rail[Int] = new Rail[Int](newSize);

        Rail.copy(this.hash, 0, newHash, 0, thisSize);
        Rail.copy(that.hash, 0, newHash, thisSize, thatSize);

        Rail.copy(this.lower, 0, newLower, 0, thisSize);
        Rail.copy(that.lower, 0, newLower, thisSize, thatSize);

        Rail.copy(this.upper, 0, newUpper, 0, thisSize);
        Rail.copy(that.upper, 0, newUpper, thisSize, thatSize);

        this.hash = newHash;
        this.lower = newLower;
        this.upper = newUpper;
    }

    @Inline public def size(): Long
    {
        return (hash.size);
    }
}