package de.uks.plm.ftglb.actor.utsg;

import x10.compiler.*;
import x10.util.Team;
import de.uks.plm.ftglb.actor.GLBResult;
import de.uks.plm.ftglb.actor.TaskQueue;
import de.uks.plm.ftglb.actor.TaskBag;

public final class Queue extends UTS implements TaskQueue[Queue, Long]
{
    var result:UTSResult = null;

    public def this(factor:Int)
    {
        super(factor);
    }

    public def this(val den:Double)
    {
        super(den);
    }

    @Inline public def process(n:Long)
    {
        var i:Long=0;
        for (; (i<n) && (size>0); ++i)
        {
            expand();
        }
        count += i;
        return size > 0;
    }

    @Inline public def split()
    {
        var s:Long = 0;
        for (var i:Long=0; i<size; ++i)
        {
            if ((upper(i) - lower(i)) >= 2) ++s;
        }
        if (s == 0) 
        {
            return null;
        }

        val bag = new Bag(s);
        s = 0;
        for (var i:Long=0; i<size; ++i)
        {
            val p = upper(i) - lower(i);
            if (p >= 2n)
            {
                bag.hash(s) = hash(i);
                bag.upper(s) = upper(i);
                upper(i) -= p/2n;
                bag.lower(s++) = upper(i);
            }
        }
        return bag;
    }

    @Inline public def merge(bag:Bag)
    {
        val bagSize = (null == bag ? 0 : bag.size());

        if (0 == bagSize)
        {
            return;
        }

        val thisSize = this.size();

        while (bagSize + thisSize > hash.size)
        {
            grow();
        }

        Rail.copy(bag.hash, 0, hash, thisSize, bagSize);
        Rail.copy(bag.lower, 0, lower, thisSize, bagSize);
        Rail.copy(bag.upper, 0, upper, thisSize, bagSize);
        size += bagSize;
    }

    @Inline public def merge(bag:TaskBag)
    {
        merge(bag as Bag);
    }

    // override
    public def printLog() {}

    @Inline public def count() :Long
    {
        return (this.count);
    }

    public def getResult(): UTSResult
    {
        val result = new UTSResult();
        return (result);
    }

    public def merge(val that:TaskQueue[Queue, Long]) : void
    {
        this.merge(that as Queue);
    }

    public def merge(val that:Queue) : void
    {
        val thisSize:Long = this.size();
        val thatSize:Long = (null == that ? 0 : that.size());
        if (0 == thatSize)
        {
            return;
        }

        while (thisSize + thatSize > hash.size)
        {
            grow();
        }
        Rail.copy(that.hash, 0, hash, thisSize, thatSize);
        Rail.copy(that.lower, 0, lower, thisSize, thatSize);
        Rail.copy(that.upper, 0, upper, thisSize, thatSize);
        size += thatSize;
    }

    public def mergeResults(val that:TaskQueue[Queue, Long]) : void
    {
        this.mergeResult(that as Queue);
    }

    public def mergeResult(val that:Queue) : void
    {
        this.count += that.count;
    }

    public def size() : Long
    {
        return (this.size);
    }

    public def makeEmptyQueue() : Queue
    {
        return new Queue (this.den);
    }

    public class UTSResult extends GLBResult[Long]
    {
        r:Rail[Long] = new Rail[Long](1l);

        public  def getResult() : Rail[Long]
        {
            r(0) = count;
            return (r);
        }

        public  def getReduceOperator() : Int
        {
            return (Team.ADD);
        }

        public def display(r:Rail[Long]) : void
        {
            Console.OUT.println("Myresult: "+r(0));
        }
    }
}